天气与日历 切换到窄版

 找回密码
 立即注册
中国膜结构网
十大进口膜材评选 十大国产膜材评选 十大膜结构设计评选 十大膜结构公司评选
查看: 82|回复: 0

arx 图层函数

[复制链接]

该用户从未签到

主题

0

回帖

2912

积分

管理员

积分
2912
发表于 2024-6-22 09:46:18 | 显示全部楼层 |阅读模式
[code]void CLayerUtil::Add( const TCHAR* layerName, int colorIndex )
{
        assert (layerName != NULL);
        assert (colorIndex >= 1 && colorIndex <= 255);                       
       
        // 获得层表
        AcDbLayerTable *pLayerTbl = NULL;
        acdbHostApplicationServices()->workingDatabase()->getSymbolTable(pLayerTbl, AcDb::kForWrite);

        // 是否已经存在同名的层
        if (!pLayerTbl->has(layerName))
        {
                AcDbLayerTableRecord *pLayerTblRcd = new AcDbLayerTableRecord();
                pLayerTblRcd->setName(layerName);
                AcCmColor color;
                color.setColorIndex(colorIndex);
                pLayerTblRcd->setColor(color);
                Acad::ErrorStatus es = pLayerTbl->add(pLayerTblRcd);
                pLayerTblRcd->close();
        }
       
        pLayerTbl->close();
}

AcDbObjectId CLayerUtil::GetLayerId( const TCHAR* layerName )
{
        assert (layerName != NULL);
       
        AcDbLayerTable *pLayerTbl;
        acdbHostApplicationServices()->workingDatabase()->getSymbolTable(pLayerTbl, AcDb::kForRead);
        AcDbObjectId layerId = AcDbObjectId::kNull;
        if (pLayerTbl->has(layerName))
        {
                pLayerTbl->getAt(layerName, layerId);
        }       
        pLayerTbl->close();       
       
        return layerId;
}

bool CLayerUtil::SetColor( const TCHAR* layerName, int colorIndex )
{
        AcDbObjectId layerId = GetLayerId(layerName);
        bool bRet = false;
        AcDbLayerTableRecord *pLayerTblRcd = NULL;
        if (acdbOpenObject(pLayerTblRcd, layerId, AcDb::kForWrite) == Acad::eOk)
        {
                AcCmColor color;
                color.setColorIndex(colorIndex);
                pLayerTblRcd->setColor(color);
                bRet = true;

                pLayerTblRcd->close();
        }

        return bRet;
}

void CLayerUtil::GetLayerList( AcDbObjectIdArray &layers )
{
        AcDbLayerTable *pLayerTbl = NULL;
        acdbHostApplicationServices()->workingDatabase()->getLayerTable(pLayerTbl, AcDb::kForRead);
        AcDbLayerTableIterator *it = NULL;
        pLayerTbl->newIterator(it);
        AcDbLayerTableRecord *pLayerTblRcd = NULL;
        for (it->start(); !it->done(); it->step())
        {
                if (it->getRecord(pLayerTblRcd, AcDb::kForRead) == Acad::eOk)
                {
                        layers.append(pLayerTblRcd->objectId());
                       
                        pLayerTblRcd->close();
                }               
        }
        delete it;
        pLayerTbl->close();
}[/code]

 

 

 

 

arx 图层函数
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|Archiver|中国膜结构网|中国膜结构协会|进口膜材|国产膜材|ETFE|PVDF|PTFE|设计|施工|安装|车棚|看台|污水池|中国膜结构网_中国空间膜结构协会

GMT+8, 2024-11-1 10:32 , Processed in 0.128183 second(s), 23 queries .

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表